//+------------------------------------------------------------------+
//|                                                                  |
//|                      Sunwest 2007                                |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Larry Williams Forextsd Unca - Sunwest 2007"
#property  link      "http://sunwest3d.free.fr"

//---- Indicator Settings
#property   indicator_separate_window
#property   indicator_buffers 2
#property   indicator_color1 Green      
#property   indicator_color2 Red

//---- Buffers
double      ExtMapBuffer1[];
double      ExtMapBuffer2[];

extern int  NGSV              = 24;    // Number of Bar to Calulate the GSV
extern int  NbarDisplayed     = 2400;  // Number of Bar being displayed
extern bool DoBarInProgress   = false;  // Calculate and draw the Bar In Progress 

double      TotOTH,TotOTL,NumBarOTH, NumBarOTL;
int         BarInProgress;

//+------------------------------------------------------------------+
//|  Indicator initialisation function                               |
//+------------------------------------------------------------------+
int init()
  {
   BarInProgress=0;
//---- Drawing Settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2,Green);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2,Red);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
//---- Initialisation done
   return(0);
  }

int start()
  {
      if (NbarDisplayed>Bars) NbarDisplayed = Bars;
      if (Volume[0]>1 && !DoBarInProgress)  BarInProgress=1; else BarInProgress=0;

      for(int shift = NbarDisplayed-NGSV; shift >= BarInProgress; shift--)
      {
         TotOTH = 0;
         TotOTL = 0;
         NumBarOTH = 0;
         NumBarOTL = 0;
         for(int i = 0 ; i < NGSV  ; i++)
         {
            if (Close[shift+i]<Open[shift+i]) {TotOTH = TotOTH + High[shift+i]-Open[shift+i];NumBarOTH++;}     // GSV for Short Bar                
            if (Close[shift+i]>Open[shift+i]) {TotOTL = TotOTL + Open[shift+i]-Low[shift+i]; NumBarOTL++;}     // GSV for Long Bar
            
            if (Close[shift+i]==Open[shift+i]) 
            {
               TotOTL = TotOTL + Open[shift+i]-Low[shift+i]; NumBarOTL++;
               TotOTH = TotOTH + High[shift+i]-Open[shift+i];NumBarOTH++;
            }     
              
         }
         if (NumBarOTH>0 && NumBarOTL>0)
         {
            ExtMapBuffer2[shift] = 0;
            ExtMapBuffer1[shift] = 0;
            ExtMapBuffer1[shift] = (TotOTH/NumBarOTH)/Point;      // Green GSV for Short Bar
            ExtMapBuffer2[shift] = -(TotOTL/NumBarOTL)/Point;     // Red   GSV for Long Bar
            Print(" TotOTH: ",TotOTH," TotOTL: ",TotOTL, " NumBarOTH: ",NumBarOTH," NumBarOTL: ", NumBarOTL);
         }
      }

      return(0);
  }
//+------------------------------------------------------------------+


